% this is copied and modified from gabaix comments 
% see the appendix to gabaix comments for algebra
% This is the final version, one with more experiments
% remains in root directory. 

clear all
close all

bet = 0.95;
k = 1/2; 
sig = 1;
phi = 1.5; 
printgraph = 1; 

% ***********************
% response to m policy shock
% **********************


lp = (1 + bet + k*sig + ((1 + bet + k*sig)^2 - 4 * 1 * bet * (1+phi*k*sig))^0.5 )/(2*(1+k*sig*phi)); 
ln = (1 + bet + k*sig - ((1 + bet + k*sig)^2 - 4 * 1 * bet * (1+phi*k*sig))^0.5 )/(2*(1+k*sig*phi));
% these are lambdas of lag operator approach, 1/lambdas of matrix approach

l1 = (1 + bet + k*sig + ((1 + bet + k*sig)^2 - 4 * bet )^0.5 )/2;
l2 = (1 + bet + k*sig - ((1 + bet + k*sig)^2 - 4 * bet )^0.5 )/2;
% these are from mm paper, lambdas of the i fixe approach

rhov = [1 0.9 1/l1 0.3]'; 
T = 10; 

figure;
default_color = get(gca,'colororder');
dark_green=default_color(3,:); 
for rhoi = 1:size(rhov,1);
    rho = rhov(rhoi);
    ihatt = zeros(T,1);
    ihatt(3) = -1; % shock
    ihatt(4:T) = -rho.^((1:T-3)');
    pit = -k*sig/(1+k*sig*phi)*1/((1-lp*rho)*(1-ln*rho))*ihatt;
    it = phi*pit + ihatt;
    
    subplot(2,2,rhoi);
    hold on
    plot((1:T)',pit,'-rs','linewidth',2)
    plot((1:T)',it,'--','color',dark_green,'linewidth',2)
    plot((1:T)',ihatt,'-m','linewidth',2)
    text(4,pit(4),'\pi','color','r','fontsize',16,'backgroundcolor','w')
    text(3,ihatt(3),'v^i','color','m','fontsize',16,'backgroundcolor','w')
    text(3,it(3),'i','color',dark_green,'fontsize',16,'backgroundcolor','w')
    %legend('\pi','i','v^i')
    xlabel('Time','fontsize',16);
    ylabel('Percent (%)','fontsize',16)
    if ~(rhoi == 3);
        title(['\rho = ' num2str(rho)],'fontsize',16);
    end;
    if (rhoi == 3);
        title(['\rho = 1/\lambda_1 \approx ' num2str(rho,'%4.2f')],'fontsize',16);
    end;
        if rhoi == 1; 
        axis([0 10 -1.25 2.3]);
    end;
    if rhoi == 2; 
        axis([0 10 -1.25 1.8]);
    end;
    if rhoi == 3; 
        axis([0 10 -1.25 0.8]);
    end;
    if rhoi == 4; 
        axis([0 10 -1.25 0.6]);
    end;
end;

print -depsc2 three_equation_response.eps